package io.tswf.minecraft.blockventure.core.api.gui.handler

import groovy.transform.CompileStatic
import io.tswf.groovy.bettergroovy.transforms.nullsafe.NullSafe
import net.minecraft.block.entity.BlockEntity
import net.minecraft.entity.player.PlayerEntity
import net.minecraft.inventory.Inventory
import net.minecraft.screen.ScreenHandlerType

@CompileStatic
class BaseBlockEntityScreenHandler<T extends BlockEntity> extends BaseQuickMoveScreenHandler {

    @NullSafe
    T blockEntity

    BaseBlockEntityScreenHandler(@NullSafe T blockEntity, int syncId) {
        super(syncId)
        this.blockEntity = blockEntity
    }

    BaseBlockEntityScreenHandler(@NullSafe T blockEntity, ScreenHandlerType screenHandlerType, int syncId) {
        super(screenHandlerType, syncId)
        this.blockEntity = blockEntity
    }

    @Override
    boolean canUse(PlayerEntity player) {
        return Inventory.canPlayerUse(blockEntity, player, getDistanceForUsing(player))
    }

    int getDistanceForUsing(PlayerEntity player) { 8 }
}
