package io.tswf.minecraft.blockventure.core.api.gui.handler

import groovy.transform.CompileStatic
import io.tswf.minecraft.blockventure.core.api.registry.GuiScreenRegistry
import io.tswf.minecraft.blockventure.core.inventory.screenhandler.MultipleSlotsQuickMoveHelper
import net.minecraft.entity.player.PlayerEntity
import net.minecraft.item.ItemStack
import net.minecraft.screen.ScreenHandler
import net.minecraft.screen.ScreenHandlerType

@CompileStatic
abstract class BaseQuickMoveScreenHandler extends BaseScreenHandler {

    IScreenHandlerMultipleSlotsQuickMoveHelper quickMovingGroups = new MultipleSlotsQuickMoveHelper(this)

    BaseQuickMoveScreenHandler(int syncId) {
        this(GuiScreenRegistry.autoSelectType, syncId)
    }

    BaseQuickMoveScreenHandler(ScreenHandlerType screenHandlerType, int syncId) {
        super(screenHandlerType, syncId)
    }

    @Override
    ItemStack quickMove(PlayerEntity player, int slot) {
        quickMovingGroups.quickMoveStack(player, slot)
    }

    @Override
    boolean canUse(PlayerEntity player) {
        return true
    }
}
