package io.tswf.minecraft.blockventure.core.api.gui.handler

import groovy.transform.CompileStatic
import io.tswf.minecraft.blockventure.core.api.registry.GuiScreenRegistry
import net.minecraft.entity.player.PlayerEntity
import net.minecraft.entity.player.PlayerInventory
import net.minecraft.inventory.Inventory
import net.minecraft.item.ItemStack
import net.minecraft.screen.ScreenHandler
import net.minecraft.screen.ScreenHandlerType

@CompileStatic
abstract class BaseScreenHandler extends ScreenHandler {

    BaseScreenHandler(int syncId) {
        this(GuiScreenRegistry.autoSelectType, syncId)
    }

    BaseScreenHandler(ScreenHandlerType screenHandlerType, int syncId) {
        super(screenHandlerType, syncId)
    }

    @Override
    ItemStack quickMove(PlayerEntity player, int slot) {
        return ItemStack.EMPTY
    }

    @Override
    boolean canUse(PlayerEntity player) {
        return true
    }

    int addGridInventorySlots(int offsetX = 8, int offsetY = 84, Inventory inventory, Iterable<Integer> indexes = null, int rowSlotsCount = 9) {
        return StandardScreenHandlerSlots.addGridInventorySlots(this, offsetX, offsetY, inventory, indexes, rowSlotsCount)
    }

    int addPlayerInventorySlots(int offsetX = 8, int offsetY = 84, PlayerInventory playerInventory) {
        return StandardScreenHandlerSlots.addPlayerInventorySlots(this, offsetX, offsetY, playerInventory)
    }
}
