package io.tswf.minecraft.blockventure.core.api.gui.handler

import groovy.transform.CompileStatic
import net.minecraft.entity.player.PlayerEntity
import net.minecraft.item.ItemStack

@CompileStatic
interface IScreenHandlerMultipleSlotsQuickMoveHelper {

    ItemStack quickMoveStack(PlayerEntity player, int slot)
    ISlotsGroup getGroup(String name)
    ISlotsGroup getAt(String name)

    static interface ISlotsGroup {
        void addSourceSlot(int slotIndex)
        void addSourceSlots(Iterable<Integer> slotIndexes)
        void addSourceSlots(Runnable run)

        void addTargetSlot(int slotIndex)
        void addTargetSlots(Iterable<Integer> slotIndexes)
        void addTargetSlots(ISlotsGroup group)
        void addTargetSlots(ISlotsGroup group, boolean sort)
        void addTargetSlots(ISlotsGroup group, boolean sort, boolean reverse)

        List<Integer> getSourceSlots()
    }

}
