package io.tswf.minecraft.blockventure.core.api.gui.handler

import groovy.transform.CompileStatic
import groovy.transform.NamedVariant
import io.tswf.minecraft.blockventure.core.transmutation.view.ViewScreenHandler
import net.minecraft.entity.player.PlayerInventory
import net.minecraft.inventory.Inventory
import net.minecraft.screen.ScreenHandler
import net.minecraft.screen.slot.Slot

@CompileStatic
class StandardScreenHandlerSlots {

    public static final int SLOT_GRID_OFFSET = 18

    @NamedVariant
    static int addGridInventorySlots(ScreenHandler screenHandler, int offsetX = 8, int offsetY = 84, Inventory inventory, Iterable<Integer> indexes = null, int rowSlotsCount = 9) {
        def viewScreenHandler = (ViewScreenHandler) screenHandler

        // Если индексы не переданы, то используем все слоты в инвентаре
        if (indexes == null) {
            indexes = (0..(inventory.size()-1))
        }

        def slotIndexesIterator = indexes.iterator()

        int row = 0
        exit: {
            while (slotIndexesIterator.hasNext()) {
                for(int col = 0; col < rowSlotsCount; col ++) {
                    if (!slotIndexesIterator.hasNext()) {
                        break exit
                    }

                    def slotIndex = slotIndexesIterator.next()

                    viewScreenHandler.callAddSlot(new Slot(inventory, slotIndex, offsetX + col * SLOT_GRID_OFFSET, offsetY + row * SLOT_GRID_OFFSET))
                }

                row ++
            }
        }

        return SLOT_GRID_OFFSET * row
    }

    static int addPlayerInventorySlots(ScreenHandler screenHandler, int offsetX = 8, int offsetY = 84, PlayerInventory playerInventory) {
        def viewScreenHandler = (ViewScreenHandler) screenHandler

        for(int row = 0; row < 9; row ++) {
            viewScreenHandler.callAddSlot(new Slot(playerInventory, row, offsetX + row * SLOT_GRID_OFFSET, offsetY + 58))
        }

        for(int row = 0; row < 3; row ++) {
            for(int col = 0; col < 9; ++col) {
                viewScreenHandler.callAddSlot(new Slot(playerInventory, col + row * 9 + 9, offsetX + col * SLOT_GRID_OFFSET, offsetY + row * SLOT_GRID_OFFSET))
            }
        }

        return offsetY + 58
    }
}
